package com.bizmatics.controller.web;


import com.bizmatics.common.core.bean.ApiResult;
import com.bizmatics.model.system.SysMenu;
import com.bizmatics.service.UserSiteService;
import com.bizmatics.service.system.ISysMenuService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.stereotype.Controller;

import java.util.List;

/**
 * 用户站点信息
 *
 * @author ya
 * @since 2021-07-07
 */
@RestController
@RequestMapping("/userSite")
public class UserSiteController {

    @Autowired
    private UserSiteService userSiteService;
    @Autowired
    private ISysMenuService menuService;


    /**
     * 根据菜单查询按钮
     * @param menuName 菜单名称
     * @return
     */
    @GetMapping(value = "/getButtonlistone")
    public ApiResult<List<SysMenu>> getButtonlistone(@RequestParam(value = "menuName", required = false) String menuName){
        return  ApiResult.success(menuService.getButtonlist(menuName));
    }

    @GetMapping(value = "/getAuthority")
    public ApiResult<List<Object>> getAuthority(@RequestParam(value = "roleId") Long roleId){
        return  ApiResult.success(menuService.getAuthority(roleId));
    }

}

